package org.jeecg.modules.projectManagement.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.projectManagement.entity.FdProjectQuotationTemplateAdd;
import org.jeecg.modules.projectManagement.service.IFdProjectQuotationTemplateAddService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

 /**
 * @Title: Controller
 * @Description: 报价新增选择的模板
 * @author： jeecg-boot
 * @date：   2019-10-22
 * @version： V1.0
 */
@RestController
@RequestMapping("/projectManagement/fdProjectQuotationTemplateAdd")
@Slf4j
public class FdProjectQuotationTemplateAddController {
	@Autowired
	private IFdProjectQuotationTemplateAddService fdProjectQuotationTemplateAddService;
	
	/**
	  * 分页列表查询
	 * @param fdProjectQuotationTemplateAdd
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<FdProjectQuotationTemplateAdd>> queryPageList(FdProjectQuotationTemplateAdd fdProjectQuotationTemplateAdd,
									  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									  HttpServletRequest req) {
		Result<IPage<FdProjectQuotationTemplateAdd>> result = new Result<IPage<FdProjectQuotationTemplateAdd>>();
		QueryWrapper<FdProjectQuotationTemplateAdd> queryWrapper = QueryGenerator.initQueryWrapper(fdProjectQuotationTemplateAdd, req.getParameterMap());
		queryWrapper.lambda().eq(FdProjectQuotationTemplateAdd::getDelFlag,"0");
		Page<FdProjectQuotationTemplateAdd> page = new Page<FdProjectQuotationTemplateAdd>(pageNo, pageSize);
		IPage<FdProjectQuotationTemplateAdd> pageList = fdProjectQuotationTemplateAddService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}
	
	/**
	  *   添加
	 * @param fdProjectQuotationTemplateAdd
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<FdProjectQuotationTemplateAdd> add(@RequestBody FdProjectQuotationTemplateAdd fdProjectQuotationTemplateAdd) {
		Result<FdProjectQuotationTemplateAdd> result = new Result<FdProjectQuotationTemplateAdd>();
		try {
			fdProjectQuotationTemplateAddService.save(fdProjectQuotationTemplateAdd);
			result.success("添加成功！");
		} catch (Exception e) {
			e.printStackTrace();
			log.info(e.getMessage());
			result.error500("操作失败");
		}
		return result;
	}
	
	/**
	  *  编辑
	 * @param fdProjectQuotationTemplateAdd
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<FdProjectQuotationTemplateAdd> edit(@RequestBody FdProjectQuotationTemplateAdd fdProjectQuotationTemplateAdd) {
		Result<FdProjectQuotationTemplateAdd> result = new Result<FdProjectQuotationTemplateAdd>();
		FdProjectQuotationTemplateAdd fdProjectQuotationTemplateAddEntity = fdProjectQuotationTemplateAddService.getById(fdProjectQuotationTemplateAdd.getId());
		if(fdProjectQuotationTemplateAddEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fdProjectQuotationTemplateAddService.updateById(fdProjectQuotationTemplateAdd);
			//TODO 返回false说明什么？
			if(ok) {
				result.success("修改成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<FdProjectQuotationTemplateAdd> delete(@RequestParam(name="id",required=true) String id) {
		Result<FdProjectQuotationTemplateAdd> result = new Result<FdProjectQuotationTemplateAdd>();
		FdProjectQuotationTemplateAdd fdProjectQuotationTemplateAdd = fdProjectQuotationTemplateAddService.getById(id);
		if(fdProjectQuotationTemplateAdd==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fdProjectQuotationTemplateAddService.removeById(id);
			if(ok) {
				result.success("删除成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<FdProjectQuotationTemplateAdd> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<FdProjectQuotationTemplateAdd> result = new Result<FdProjectQuotationTemplateAdd>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.fdProjectQuotationTemplateAddService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}
	
	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<FdProjectQuotationTemplateAdd> queryById(@RequestParam(name="id",required=true) String id) {
		Result<FdProjectQuotationTemplateAdd> result = new Result<FdProjectQuotationTemplateAdd>();
		FdProjectQuotationTemplateAdd fdProjectQuotationTemplateAdd = fdProjectQuotationTemplateAddService.getById(id);
		if(fdProjectQuotationTemplateAdd==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(fdProjectQuotationTemplateAdd);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<FdProjectQuotationTemplateAdd> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              FdProjectQuotationTemplateAdd fdProjectQuotationTemplateAdd = JSON.parseObject(deString, FdProjectQuotationTemplateAdd.class);
              queryWrapper = QueryGenerator.initQueryWrapper(fdProjectQuotationTemplateAdd, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<FdProjectQuotationTemplateAdd> pageList = fdProjectQuotationTemplateAddService.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "报价新增选择的模板列表");
      mv.addObject(NormalExcelConstants.CLASS, FdProjectQuotationTemplateAdd.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("报价新增选择的模板列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<FdProjectQuotationTemplateAdd> listFdProjectQuotationTemplateAdds = ExcelImportUtil.importExcel(file.getInputStream(), FdProjectQuotationTemplateAdd.class, params);
              for (FdProjectQuotationTemplateAdd fdProjectQuotationTemplateAddExcel : listFdProjectQuotationTemplateAdds) {
                  fdProjectQuotationTemplateAddService.save(fdProjectQuotationTemplateAddExcel);
              }
              return Result.ok("文件导入成功！数据行数：" + listFdProjectQuotationTemplateAdds.size());
          } catch (Exception e) {
              log.error(e.getMessage());
              return Result.error("文件导入失败！");
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

}
